import greenfoot.*;
import java.util.Vector;
public class Game extends World
{
    public static final int SCALE = 25;
    public static final boolean ai = false;
    Snake head, tail;
    Food food;
    String lastKey;
    int[] v = new int[2];
    public Game(){
        super(25, 20, SCALE);
        getBackground().setColor(Color.DARK_GRAY);
        getBackground().fill();
        head = tail = new Snake(null);
        addObject(head, getWidth() / 2, getHeight() / 2);
        food = new Food();
        navi = new Navi(this);
        v[0] = 1;
        v[1] = 0;
        addObject(food, 0, 0);
        addFood();
        Greenfoot.setSpeed(35);
        showText("Global high score: " + getTopScore(), getWidth() / 2, 1);
        Greenfoot.start();
    }
    public void act(){
        if(ai)ai();
        runGame();
    }
    private void runGame(){
        String key = getKey();
        if(key.equals("up")/*&&v[1]==0*/){
            v[0] = 0;
            v[1] = -1;
        }
        else if(key.equals("down")/*&&v[1]==0*/){
            v[0] = 0;
            v[1] = 1;
        }
        else if(key.equals("left")/*&&v[0]==0*/){
            v[0] = -1;
            v[1] = 0;
        }
        else if(key.equals("right")/*&&v[0]==0*/){
            v[0] = 1;
            v[1] = 0;
        }
        tail.update();
        head.setLocation(head.getX() + v[0], head.getY() + v[1]);
        if(head.getX()==food.getX()&&head.getY()==food.getY()){
            addFood();
            tail = tail.extend();
        }
        else if(getObjectsAt(head.getX(), head.getY(), Snake.class).size()>1){
            getBackground().setColor(Color.WHITE);
            getBackground().drawString(tail.size() + "", getWidth() / 2, getHeight() / 2);
            showText(tail.size() + "", getWidth() / 2, getHeight() / 2);
            updateScore(tail.size());
            while(true){
                key = Greenfoot.getKey();
                if(key!=null){
                    Greenfoot.setWorld(new Game());
                    break;
                }
            }
        }
    }
    private void addFood(){
        do{
            food.setLocation((int)(Math.random() * getWidth()), (int)(Math.random() * getHeight()));
        }while(getObjectsAt(food.getX(), food.getY(), Snake.class).size()>0);
        //getPath();
    }
    private String getKey(){
        String key;
        if(virtualKey!=null){
            key = virtualKey.toString();
            virtualKey = null;
        }
        else{
            key = Greenfoot.getKey();
            if(key==null){
                if(!"up".equals(lastKey)&&Greenfoot.isKeyDown("up"))key = "up";
                if(!"down".equals(lastKey)&&Greenfoot.isKeyDown("down"))key = "down";
                if(!"left".equals(lastKey)&&Greenfoot.isKeyDown("left"))key = "left";
                if(!"reight".equals(lastKey)&&Greenfoot.isKeyDown("right"))key = "right";
            }
            if(key==null)key = "";
            lastKey = key;
        }
        return key;
    }
    String virtualKey;
    public void emulate(String key){
        virtualKey = key;
    }
    
    private Navi navi;
    private java.util.ArrayList<Navi.Point> path;
    private void ai(){
        getPath();
        if(path!=null){
            if(path.get(1).x<head.getX())emulate("left");
            else if(path.get(1).x>head.getX())emulate("right");
            else if(path.get(1).y>head.getY())emulate("down");
            else if(path.get(1).y<head.getY())emulate("up");
        }
        else{
            if(getObjectsAt(head.getX() + v[0], head.getY() + v[1], Snake.class).size()>0
            ||head.getX() + v[0] >= getWidth()||head.getX() + v[0] < 0
            ||head.getY() + v[1] >= getHeight()||head.getY() + v[1] < 0){
                if(v[0]==1){//right
                    if(getObjectsAt(head.getX(), head.getY() + 1, Snake.class).size()==0){
                        emulate("down");
                    }
                    else if(getObjectsAt(head.getX(), head.getY() - 1, Snake.class).size()==0){
                        emulate("up");
                    }
                }
                else if(v[0]==-1){//left
                    if(getObjectsAt(head.getX(), head.getY() - 1, Snake.class).size()==0){
                        emulate("up");
                    }
                    else if(getObjectsAt(head.getX(), head.getY() + 1, Snake.class).size()==0){
                        emulate("down");
                    }
                }
                else if(v[1]==1){//down
                    if(getObjectsAt(head.getX() + 1, head.getY(), Snake.class).size()==0){
                        emulate("right");
                    }
                    else if(getObjectsAt(head.getX() - 1, head.getY(), Snake.class).size()==0){
                        emulate("left");
                    }
                }
                else if(v[1]==-1){//up
                    if(getObjectsAt(head.getX() - 1, head.getY(), Snake.class).size()==0){
                        emulate("left");
                    }
                    else if(getObjectsAt(head.getX() + 1, head.getY(), Snake.class).size()==0){
                        emulate("right");
                    }
                }
            }
        }
    }
    private void getPath(){
        path = navi.getPath(head.getX(), head.getY(), food.getX(), food.getY());
    }
    
    public static int getTopScore(){
        try{
            return ((UserInfo)UserInfo.getTop(1).get(0)).getScore();
        }catch(Exception e){System.out.println(e);return 0;}
    }
    public static void updateScore(int newScore){
        try{
            UserInfo server = UserInfo.getMyInfo();
            int oldScore = server.getScore();
            if(newScore > oldScore){
                server.setScore(newScore);
                server.store();
            }
        }catch(Exception e){}
    }
}