import greenfoot.World;

public class Navi{
    public Point[][] points;
    private World world;
    private int aimX, aimY;

    public Navi(World world){
        this.world = world;
    }

    public java.util.ArrayList<Point> getPath(int homeX, int homeY, int aimX, int aimY){
        this.aimX = aimX;
        this.aimY = aimY;
        points = new Point[world.getWidth()][world.getHeight()];
        points[homeX][homeY] = new Point(homeX, homeY, null);
        while(true){
            Point point = null;
            int n = 0;
            for(Point[] p : points){for(Point q : p){
                    if(q != null){
                        if((point == null || q.getDistance() < point.getDistance()) && !q.explored()){
                            point = q;
                        }
                        else n++;
                    }
                }
            }
            //System.out.println(n);
            if(point==null)return null;
            Point[] newPoints = point.explore();
            for(Point[] p : points){for(Point q : p){
                if(q != null && q.x == aimX && q.y == aimY)return q.getPath();
            }}
        }
    }

    public boolean available(int x, int y){
        try{
            if(points[x][y] != null) return false;
            return world.getObjectsAt(x, y, Snake.class).size() == 0;
        }catch(Exception e){return false;}
    }

    public class Point{
        public int x, y;
        private boolean explored;
        private Point last;

        public Point(int x, int y, Point last){
            this.x = x;
            this.y = y;
            this.last = last;
            explored = false;
        }

        public Point[] explore(){
            Point[] newPoints = new Point[4];
            if(available(x + 1, y))points[x + 1][y] = newPoints[0] = new Point(x + 1, y, this);
            if(available(x - 1, y))points[x - 1][y] = newPoints[1] = new Point(x - 1, y, this);
            if(available(x, y + 1))points[x][y + 1] = newPoints[2] = new Point(x, y + 1, this);
            if(available(x, y - 1))points[x][y - 1] = newPoints[3] = new Point(x, y - 1, this);
            explored = true;
            return newPoints;
        }

        public int getDistance(){
            return getHomeDistance() + (int)Math.sqrt(Math.pow(aimX - x, 2) + Math.pow(aimY - y, 2));
        }

        private int getHomeDistance(){
            if(last == null)return 0;
            return last.getHomeDistance() + 1;
        }

        public java.util.ArrayList<Point> getPath(){
            java.util.ArrayList<Point> path = new java.util.ArrayList<Point>();
            path.add(this);
            if(last != null)path.addAll(0, last.getPath());
            return path;
        }

        public boolean explored(){
            return explored;
        }
    }
}